MODULE PL0;  (*NW WS 83/84*)

IMPORT Args, FIO;
IMPORT PL0Scanner, PL0Parser, PL0Generator, PL0Interpreter;

CONST
  err ::= FIO.ErrorOutput;

PROCEDURE Options();
BEGIN
  WHILE Args.sym = Args.symOpt DO
    Args.Read();
  END;
END Options;

BEGIN
  Args.Read(); Options();
  WHILE Args.sym = Args.symArg DO
    IF FIO.Exists( Args.lit ) THEN
      PL0Scanner.src := FIO.OpenRead( Args.lit );
      PL0Scanner.Init();
      PL0Generator.Init();
      PL0Parser.Run();
      PL0Scanner.Close();
      PL0Generator.End();
      FIO.Close( PL0Scanner.src );
      IF PL0Parser.noErr THEN
        PL0Interpreter.Run();
      ELSE
        FIO.WrStr( err, 'Incorrect: "' );
        FIO.WrStr( err, Args.lit );
        FIO.WrStr( err, '".' );
        FIO.WrLn( err );
      END;
    ELSE
      FIO.WrStr( err, 'File not found: "' );
      FIO.WrStr( err, Args.lit );
      FIO.WrStr( err, '".' );
      FIO.WrLn( err );
    END;
    Args.Read(); Options();
  END;
END PL0.
